#ifndef lint
static const char yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93";
#endif

#include <stdlib.h>

#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYPATCH 20070509

#define YYEMPTY (-1)
#define yyclearin    (yychar = YYEMPTY)
#define yyerrok      (yyerrflag = 0)
#define YYRECOVERING (yyerrflag != 0)

extern int yyparse(void);

static int yygrowstack(void);
#define YYPREFIX "yy"
#line 2 "cfg-grammar.y"

#include "syslog-ng.h"
#include "cfg.h"
#include "sgroup.h"
#include "dgroup.h"
#include "center.h"
#include "filter.h"
#include "templates.h"
#include "logreader.h"

#include "affile.h"
#include "afinter.h"
#include "afsocket.h"
#include "afinet.h"
#include "afunix.h"
#include "afstreams.h"
#include "afuser.h"
#include "afprog.h"

#include "messages.h"

#include "syslog-names.h"

#include <netinet/in.h>
#include <stdio.h>
#include <stdlib.h>

int lookup_parse_flag(char *flag);

void yyerror(char *msg);
int yylex();

LogDriver *last_driver;
LogReaderOptions *last_reader_options;
LogWriterOptions *last_writer_options;
LogTemplate *last_template;
SocketOptions *last_sock_options;
gint last_addr_family = AF_INET;

#if ! ENABLE_IPV6
#undef AF_INET6
#define AF_INET6 0; g_assert_not_reached()

#endif

#line 49 "cfg-grammar.y"
typedef union {
	guint num;
	char *cptr;
	void *ptr;
	FilterExprNode *node;
} YYSTYPE;
#line 75 "cfg-grammar.c"
#define KW_SOURCE 257
#define KW_DESTINATION 258
#define KW_LOG 259
#define KW_OPTIONS 260
#define KW_FILTER 261
#define KW_INTERNAL 262
#define KW_FILE 263
#define KW_PIPE 264
#define KW_UNIX_STREAM 265
#define KW_UNIX_DGRAM 266
#define KW_TCP 267
#define KW_UDP 268
#define KW_TCP6 269
#define KW_UDP6 270
#define KW_USER 271
#define KW_DOOR 272
#define KW_SUN_STREAMS 273
#define KW_PROGRAM 274
#define KW_FSYNC 275
#define KW_MARK_FREQ 276
#define KW_STATS_FREQ 277
#define KW_FLUSH_LINES 278
#define KW_FLUSH_TIMEOUT 279
#define KW_LOG_MSG_SIZE 280
#define KW_FILE_TEMPLATE 281
#define KW_PROTO_TEMPLATE 282
#define KW_CHAIN_HOSTNAMES 283
#define KW_NORMALIZE_HOSTNAMES 284
#define KW_KEEP_HOSTNAME 285
#define KW_CHECK_HOSTNAME 286
#define KW_BAD_HOSTNAME 287
#define KW_KEEP_TIMESTAMP 288
#define KW_USE_DNS 289
#define KW_USE_FQDN 290
#define KW_DNS_CACHE 291
#define KW_DNS_CACHE_SIZE 292
#define KW_DNS_CACHE_EXPIRE 293
#define KW_DNS_CACHE_EXPIRE_FAILED 294
#define KW_DNS_CACHE_HOSTS 295
#define KW_PERSIST_ONLY 296
#define KW_TZ_CONVERT 297
#define KW_TS_FORMAT 298
#define KW_FRAC_DIGITS 299
#define KW_LOG_FIFO_SIZE 300
#define KW_LOG_FETCH_LIMIT 301
#define KW_LOG_IW_SIZE 302
#define KW_LOG_PREFIX 303
#define KW_FLAGS 304
#define KW_CATCHALL 305
#define KW_FALLBACK 306
#define KW_FINAL 307
#define KW_FLOW_CONTROL 308
#define KW_PAD_SIZE 309
#define KW_TIME_ZONE 310
#define KW_RECV_TIME_ZONE 311
#define KW_SEND_TIME_ZONE 312
#define KW_TIME_REOPEN 313
#define KW_TIME_REAP 314
#define KW_TIME_SLEEP 315
#define KW_TMPL_ESCAPE 316
#define KW_OPTIONAL 317
#define KW_CREATE_DIRS 318
#define KW_OWNER 319
#define KW_GROUP 320
#define KW_PERM 321
#define KW_DIR_OWNER 322
#define KW_DIR_GROUP 323
#define KW_DIR_PERM 324
#define KW_TEMPLATE 325
#define KW_TEMPLATE_ESCAPE 326
#define KW_FOLLOW_FREQ 327
#define KW_OVERWRITE_IF_OLDER 328
#define KW_KEEP_ALIVE 329
#define KW_MAX_CONNECTIONS 330
#define KW_LOCALIP 331
#define KW_IP 332
#define KW_LOCALPORT 333
#define KW_PORT 334
#define KW_DESTPORT 335
#define KW_IP_TTL 336
#define KW_SO_BROADCAST 337
#define KW_IP_TOS 338
#define KW_SO_SNDBUF 339
#define KW_SO_RCVBUF 340
#define KW_SO_KEEPALIVE 341
#define KW_SPOOF_SOURCE 342
#define KW_USE_TIME_RECVD 343
#define KW_FACILITY 344
#define KW_LEVEL 345
#define KW_HOST 346
#define KW_MATCH 347
#define KW_NETMASK 348
#define KW_YES 349
#define KW_NO 350
#define KW_REQUIRED 351
#define KW_ALLOW 352
#define KW_DENY 353
#define KW_GC_IDLE_THRESHOLD 354
#define KW_GC_BUSY_THRESHOLD 355
#define KW_COMPRESS 356
#define KW_MAC 357
#define KW_AUTH 358
#define KW_ENCRYPT 359
#define DOTDOT 360
#define IDENTIFIER 361
#define NUMBER 362
#define STRING 363
#define KW_OR 364
#define KW_AND 365
#define KW_NOT 366
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    0,   55,   55,   56,   56,   56,   56,   56,   56,    1,
    2,    3,    4,   57,    5,   58,   58,   59,   59,   60,
   60,   60,   60,   61,   61,   61,    6,    6,    7,    7,
    7,    7,    8,    9,    9,   63,   10,   65,   11,   64,
   64,   12,   12,   66,   12,   67,   12,   68,   12,   69,
   12,   71,   13,   72,   14,   70,   70,   73,   73,   73,
   73,   73,   73,   73,   76,   15,   75,   75,   77,   77,
   77,   78,   78,   78,   78,   80,   16,   79,   79,   81,
   81,   81,   81,   17,   17,   18,   83,   19,   82,   82,
   84,   62,   62,   74,   74,   74,   74,   74,   74,   74,
   74,   74,   20,   20,   21,   21,   22,   22,   22,   22,
   22,   23,   86,   24,   85,   85,   87,   87,   87,   87,
   87,   87,   87,   87,   87,   87,   87,   25,   90,   26,
   89,   89,   91,   91,   91,   91,   27,   27,   92,   27,
   93,   27,   94,   27,   95,   27,   97,   28,   98,   29,
   96,   96,   99,   99,  101,   30,  100,  100,  103,  103,
  103,  102,  102,  102,  102,  102,  105,   31,  104,  104,
  106,  106,  106,  106,   32,   33,  108,   34,  107,  107,
   88,   88,   88,   88,   88,   88,   88,   88,   88,   35,
   35,   36,   37,   37,   38,   38,   38,   39,   39,   40,
   40,   41,   41,   41,   41,   42,   42,   43,   43,   43,
   43,   43,   43,   43,   43,   43,   43,   43,   43,   43,
   43,   43,   43,   43,   43,   43,   43,   43,   43,   43,
   43,   43,   43,   43,   43,   43,   43,   43,   43,   43,
   43,   43,   43,   43,   43,   43,   43,   44,   45,   45,
   45,   45,   45,   46,   46,   46,   46,   46,   46,   46,
   46,   47,   47,   48,   49,   49,   50,   50,   51,   51,
   51,   52,   52,   53,   53,   54,   54,
};
short yylen[] = {                                         2,
    1,    3,    0,    2,    2,    2,    2,    2,    2,    4,
    4,    4,    3,    0,    5,    3,    0,    4,    4,    4,
    4,    4,    4,    1,    4,    4,    3,    0,    1,    1,
    1,    1,    3,    4,    4,    0,    3,    0,    3,    4,
    1,    4,    4,    0,    5,    0,    5,    0,    5,    0,
    5,    0,    3,    0,    3,    2,    0,    4,    4,    4,
    4,    1,    1,    1,    0,    2,    2,    0,    1,    4,
    4,    4,    4,    1,    1,    0,    2,    2,    0,    1,
    4,    4,    1,    4,    4,    4,    0,    3,    2,    0,
    4,    2,    0,    4,    4,    4,    4,    4,    4,    4,
    4,    4,    2,    0,    3,    0,    1,    1,    1,    1,
    1,    4,    0,    3,    2,    0,    1,    4,    4,    4,
    4,    4,    4,    4,    4,    4,    4,    4,    0,    3,
    2,    0,    1,    4,    4,    4,    4,    4,    0,    5,
    0,    5,    0,    5,    0,    5,    0,    3,    0,    3,
    2,    0,    1,    1,    0,    3,    2,    0,    4,    1,
    1,    1,    4,    4,    4,    4,    0,    3,    2,    0,
    1,    4,    4,    4,    4,    4,    0,    3,    2,    0,
    4,    4,    4,    4,    4,    4,    4,    4,    4,    2,
    0,    1,    3,    0,    4,    4,    4,    5,    0,    2,
    0,    1,    1,    1,    1,    3,    0,    4,    4,    4,
    4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
    4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
    4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
    4,    4,    4,    4,    4,    4,    4,    5,    1,    2,
    3,    3,    3,    4,    4,    4,    4,    4,    4,    4,
    4,    2,    1,    1,    2,    1,    3,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,
};
short yydefred[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    1,    0,  274,
  275,    4,    0,    5,    0,    0,    6,    0,    9,    7,
    0,    8,   14,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    2,    0,    0,    0,    0,
    0,   46,   44,   50,   48,    0,    0,    0,   29,   30,
   31,   32,    0,    0,    0,    0,  141,  139,  145,  143,
    0,    0,    0,    0,  107,  108,  109,  110,  111,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   13,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  249,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   10,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   11,    0,    0,    0,    0,    0,   12,  193,    0,
    0,    0,    0,    0,    0,    0,  269,  270,  271,    0,
    0,    0,    0,    0,    0,  273,  272,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  277,  276,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  206,    0,    0,    0,
    0,    0,    0,    0,  250,    0,    0,    0,    0,    0,
    0,    0,    0,   33,    0,   36,    0,   38,    0,   54,
    0,   52,   76,   65,   76,   65,    0,   87,   27,    0,
  113,    0,  129,    0,  149,    0,  147,    0,    0,    0,
    0,    0,    0,  177,  105,  195,  197,  196,  202,  203,
  204,  205,    0,    0,  208,  209,  210,  211,  226,  244,
  245,  212,  213,  214,  215,  216,  227,  219,  218,  239,
  240,  241,  242,  243,  228,  229,  223,  225,  224,  246,
  247,  220,  221,  222,  232,  233,  234,  235,  236,  237,
  238,  217,  231,  230,    0,    0,  264,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  253,    0,  252,  248,
    0,    0,   15,    0,   34,    0,   35,    0,   43,    0,
   42,    0,    0,    0,    0,    0,    0,    0,   86,    0,
  112,    0,  128,    0,  138,  152,  137,  152,    0,  167,
    0,  155,    0,    0,  175,  176,    0,    0,  200,  260,
  257,  255,  254,  262,    0,  256,  265,  258,  259,  261,
    0,    0,   16,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   37,    0,    0,   41,   39,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   62,   64,   55,
    0,   63,   53,   47,    0,    0,    0,    0,    0,    0,
   83,   24,   75,   74,   80,   77,    0,   45,    0,    0,
   66,    0,   69,   51,   49,    0,   88,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  114,    0,  117,
    0,    0,    0,  133,  130,    0,    0,    0,  142,  170,
  140,  158,  146,  144,    0,  178,  198,  267,   18,   19,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   92,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   56,    0,    0,    0,    0,    0,    0,   78,    0,
    0,   67,    0,   89,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  115,    0,    0,    0,  131,  154,  153,
  151,    0,    0,  179,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  192,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  160,  161,  171,  169,    0,    0,    0,    0,
  157,  162,   95,  102,   97,   96,   98,  103,   94,   99,
  101,  100,   40,   61,   58,   59,   60,   84,   85,   22,
   20,   21,   23,   72,   73,   81,   82,   25,   26,   70,
   71,   91,  127,  183,  184,  188,  189,  182,  181,  190,
  187,  118,  125,  119,  120,  121,  122,  123,  124,  185,
  186,  126,  134,  135,  136,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  159,  172,  173,  174,  163,  164,  165,  166,
};
short yydgoto[] = {                                       7,
   12,   14,   17,   19,   22,   87,   88,   89,   90,  265,
  267,   91,  271,  269,  375,  373,  438,   92,  277,  581,
  103,  104,  105,  280,  106,  282,  107,  286,  284,  391,
  389,  108,  109,  293,  612,  613,   30,   31,  114,  303,
  304,   72,   73,   20,  167,  168,  349,  350,  352,  353,
  210,  218,  237,  238,    8,    9,   75,  262,  263,  452,
  453,  423,  366,  427,  368,  176,  175,  178,  177,  440,
  372,  370,  441,  454,  461,  376,  462,  455,  456,  374,
  457,  467,  380,  468,  488,  382,  489,  490,  495,  384,
  496,  187,  186,  189,  188,  497,  388,  386,  571,  573,
  502,  641,  635,  572,  500,  636,  506,  397,
};
short yysindex[] = {                                   -217,
 -292, -292,  -92,  -84, -292, -292,    0,    0,  -14,    0,
    0,    0,  -73,    0,  -63, -206,    0,  169,    0,    0,
  -58,    0,    0, -217, -106, -141,   30,   44,   51, -207,
   39,   59,   62,   63,   64,   66,   73,   79,   91,   92,
   99,  102,  103,  104,  106,  107,  110,  111,  112,  113,
  125,  126,  128,  129,  137,  139,  145,  147,  148,  151,
  152,  153,  154,  158,  160,  163,  164,  165,  166,  170,
  171,   84,  155,  -38,   93,    0,  175,  177,  178,  179,
  180,    0,    0,    0,    0,  181,   97,  167,    0,    0,
    0,    0,  184,  185,  190,  191,    0,    0,    0,    0,
  192,  194,  115,  176,    0,    0,    0,    0,    0, -292,
 -292, -292,  197,  116, -206, -120, -119, -117, -116, -113,
 -292, -292, -301, -301, -301, -301, -125, -301, -267, -301,
 -301, -112, -104, -103, -292, -292, -101,  -90,  -89,  -87,
 -292, -292,  -86,  -85,  -83, -301, -299, -299,  -82, -299,
 -299,  -81, -301,  -79,  -78,    0,  169,  216,  217,  238,
  245,  246,  251,  252,  -38,  -38,  -41,    0, -245,  258,
 -292, -292, -292, -292,  260,  261,  262,  265, -292,    0,
 -106, -292, -292, -292, -292,  272,  276,  277,  278, -292,
 -292,    0, -141,  279,  281,  285, -249,    0,    0,  286,
  288,  289,  290,  293,  294,  295,    0,    0,    0,  296,
  301,  302,  303,  304,  306,    0,    0,  316,  318,  320,
  321,  322,  324,  326,  327,  328,  329,  330,  331,  332,
  333,  334,  335,  336,  337,    0,    0,  342,  343,  344,
  345,  350,  351,  352,  354,  355,    0, -292, -292, -285,
    3, -292, -292, -292,    0,  -32,  -38,  -38,  273,  357,
  359,  275,  353,    0,  368,    0,  370,    0,  373,    0,
  374,    0,    0,    0,    0,    0,  375,    0,    0,  376,
    0,  377,    0,  378,    0,  379,    0, -292, -292, -292,
 -292,  382,  385,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  387, -249,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  388,  389,    0,  392,  393,   76,
   80,  397,    3,  398,  400,  401,    0,  100,    0,    0,
 -292, -301,    0, -245,    0,   78,    0,   -6,    0,  323,
    0,  323,  402,  268,  425,  366,  431,  432,    0,  202,
    0,  410,    0, -124,    0,    0,    0,    0,  434,    0,
  435,    0,  436,  437,    0,    0, -232,  420,    0,    0,
    0,    0,    0,    0,  124,    0,    0,    0,    0,    0,
  445,  453,    0,  455,  456,  457,  458,  459,  460,  461,
  462,  463,    0,   78,  464,    0,    0,  465,  466,  467,
  468,  469,  470,  471,  473,  475,  476,    0,    0,    0,
  323,    0,    0,    0,  478,  479,  480,  481,  482,  485,
    0,    0,    0,    0,    0,    0,  268,    0,  486,  487,
    0,  366,    0,    0,    0,  488,    0,  202,  489,  490,
  491,  494,  495,  496,  497,  498,  499,  500,  501,  503,
  504,  505,  506,  509,  510,  512,  513,    0,  410,    0,
  514,  515,  517,    0,    0, -124, -225, -225,    0,    0,
    0,    0,    0,    0, -232,    0,    0,    0,    0,    0,
  196, -301,  199,  200, -292,  198,  211, -292,  212,    0,
 -301, -301, -299, -299,  213, -301,  214, -301,  218,  219,
 -301,    0, -292, -292, -299, -299,  220,  221,    0, -299,
 -299,    0, -292,    0, -301,  222,  224, -292,  225,  226,
  263, -292, -301, -301, -299, -299,  227, -299, -299,  228,
 -292, -301,  229,    0, -299, -299,  230,    0,    0,    0,
    0,   15,  -71,    0,  552,  553,  555,  569,  571,  198,
  572,  573,  574,  575,  576,  577,  578,  579,  580,  581,
  582,  587,  588,  589,  590,  593,  594,  595,  596,  597,
  598,  600,  604,  606,  607,  608,  610,  614,  615,  616,
    0,  617,  263,  618,  620,  624,  625,  630,  631,  632,
  633,  636,  637,  638,  639,  640,  641,  642,  644,  646,
  647,  650,    0,    0,    0,    0,  651,  652,  654,  656,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, -292, -299, -299, -299, -299,
 -299, -299, -301,  660,  670,  671,  672,  674,  675,  676,
  677,    0,    0,    0,    0,    0,    0,    0,    0,
};
short yyrindex[] = {                                    719,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, -105,    0,  599,    0,    0,
    0,    0,    0,  719,  601,  612,    0,    0,    0,  619,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, -105,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  599,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  621,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  601,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  612,    0,    0,    0,  680,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  680,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  681,
  -22,    0,  682,    0,    0,    0,    0,  -26,    0,    0,
    0,    0,    0,  621,    0,  684,    0,  684,    0,  698,
    0,  698,    0,  699,    0,  700,    0,    0,    0,  701,
    0,  702,    0,  704,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  706,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  684,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  698,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  699,    0,    0,    0,
    0,  700,    0,    0,    0,    0,    0,  701,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  702,    0,
    0,    0,    0,    0,    0,  704,  707,  708,    0,    0,
    0,    0,    0,    0,  706,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  709,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  710,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  711,  712,    0,    0,    0,    0,    0,    0,  709,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  710,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,
};
short yygindex[] = {                                      0,
    0,    0,    0,    0,    0,  583,    0,    0,    0,    0,
    0,    0,    0,    0,  483,  492, -352,    0,    0,  174,
  562,    0,    0,    0,    0,    0,    0,    0,    0,  472,
  484,    0,    0,    0,  143,    0,  643,    0,    0,  474,
    0,  603,    0,    0, -140,    0,  407,    0,  408,    0,
 -118,    0,   -1, -134,  738,    0,    0,  404,    0, -349,
 -485, -338,    0,    0,    0,    0,    0,    0,    0, -345,
    0,    0,    0, -334,  307,    0,    0, -373,  308,    0,
    0,  298,    0,    0,  282,    0,    0, -360,  274,    0,
    0,    0,    0,    0,    0,  384,    0,    0,    0,    0,
    0,    0,  203,    0,    0,    0,  270,    0,
};
#define YYTABLESIZE 778
short yytable[] = {                                      13,
   15,  166,  463,   21,   23,  211,  212,  213,  357,  215,
  217,  219,  220,  239,  251,  241,  242,  259,  268,  194,
  439,  451,  439,  494,  255,  256,  443,  235,  216,  426,
   16,  424,  251,  424,  244,  442,  505,  442,   18,    1,
    2,    3,    4,    5,   24,  470,  471,  207,  208,   25,
   27,   28,  470,  471,   29,  299,  300,  301,  302,   26,
  209,   10,  236,   11,   74,  472,  473,  474,   10,  110,
   11,  475,  472,  473,  474,  347,  348,  476,  475,  260,
  261,  207,  208,  111,  476,  520,  633,  633,  463,  424,
  112,  439,  485,  486,  209,  532,  113,  115,  116,  485,
  486,  117,  118,  119,  451,  120,  442,    6,  194,  195,
  196,  434,  121,  435,  436,  437,  358,  359,  122,  205,
  206,   93,   94,   95,   96,   97,   98,   99,  100,  101,
  123,  124,  102,  224,  225,  494,  570,  570,  125,  230,
  231,  126,  127,  128,  505,  129,  130,  569,  569,  131,
  132,  133,  134,  470,  471,   77,   78,   79,   80,   81,
   82,   83,   84,   85,  135,  136,   86,  137,  138,  266,
  268,  270,  272,  472,  473,  474,  139,  278,  140,  475,
  281,  283,  285,  287,  141,  476,  142,  143,  292,  294,
  144,  145,  146,  147,  491,  492,  493,  148,  194,  149,
  485,  486,  150,  151,  152,  153,  470,  471,  156,  154,
  155,  634,  634,  157,  170,  169,  171,  172,  173,  174,
  179,  180,  158,  182,  183,  181,  472,  473,  474,  184,
  185,  190,  475,  191,  193,  159,  197,  214,  476,  192,
  198,  200,  201,  412,  202,  203,  345,  346,  204,  221,
  354,  355,  356,  485,  486,  248,  249,  222,  223,  629,
  226,  637,  638,  639,  449,  434,  450,  435,  436,  437,
  640,  227,  228,  414,  229,  232,  233,  250,  234,  240,
  243,  415,  245,  246,  251,  252,  390,  392,  390,  392,
  253,  254,  470,  471,  416,  417,  418,  419,  264,  273,
  274,  275,  420,  421,  276,  160,  161,  162,  163,  164,
  425,  288,  472,  473,  474,  289,  290,  291,  475,  296,
  422,  297,  257,  258,  476,  298,  305,  165,  306,  307,
  308,  257,  258,  309,  310,  311,  312,  251,  268,  485,
  486,  313,  314,  315,  316,  629,  317,  630,  631,  632,
  449,  434,  450,  435,  436,  437,  318,  414,  319,  411,
  320,  321,  322,  351,  323,  415,  324,  325,  326,  327,
  328,  329,  330,  331,  332,  333,  334,  335,  416,  417,
  418,  419,  336,  337,  338,  339,  420,  421,  587,  588,
  340,  341,  342,  576,  343,  344,  361,  360,  362,  363,
  598,  599,  585,  586,  422,  602,  603,  590,  365,  592,
  367,  364,  595,  369,  371,  379,  381,  383,  385,  387,
  617,  618,  395,  620,  621,  396,  605,  398,  400,  401,
  626,  627,  402,  403,  615,  616,  347,  406,  408,  405,
  409,  410,  444,  624,   32,   33,   34,   35,   36,   37,
   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,
   48,   49,   50,   51,  258,  458,   52,   53,   54,   55,
   56,  464,  465,  466,  499,  501,  503,  504,  507,   57,
   58,   59,   60,   61,  508,  509,   62,   63,   64,   65,
   66,   67,   68,  510,  511,  512,  513,  514,  515,  516,
  517,  518,  519,  521,  522,  523,  524,  525,  526,  527,
  528,   69,  529,  579,  530,  531,  583,  533,  534,  535,
  536,  537,   70,   71,  538,  540,  541,  543,  545,  546,
  547,  596,  597,  548,  549,  550,  551,  552,  553,  554,
  555,  604,  556,  557,  558,  559,  608,  414,  560,  561,
  614,  562,  563,  565,  566,  415,  567,  575,  580,  623,
  577,  578,  705,  706,  707,  708,  709,  710,  416,  417,
  418,  419,  582,  584,  589,  591,  420,  421,  611,  593,
  594,  600,  601,  606,  711,  607,  609,  610,  619,  622,
  625,  628,  643,  644,  422,  645,  432,  433,  445,  446,
  447,  448,  414,  449,  434,  450,  435,  436,  437,  646,
  415,  647,  649,  650,  651,  652,  653,  654,  655,  656,
  657,  658,  659,  416,  417,  418,  419,  660,  661,  662,
  663,  420,  421,  664,  665,  666,  667,  668,  669,  428,
  670,  429,  430,  431,  671,  414,  672,  673,  674,  422,
  675,  432,  433,  415,  676,  677,  678,  679,  681,  434,
  682,  435,  436,  437,  683,  684,  416,  417,  418,  419,
  685,  686,  687,  688,  420,  421,  689,  690,  691,  692,
  693,  694,  695,  696,  469,  697,  698,  470,  471,  699,
  700,  701,  422,  702,  704,  703,  445,  446,  459,  460,
  712,  449,  434,  450,  435,  436,  437,  472,  473,  474,
  713,  714,  715,  475,  716,  717,  718,  719,    3,  476,
  201,  263,  266,  207,   93,   28,  477,  478,  479,  480,
  481,  482,  483,  484,  485,  486,  106,  487,   57,   79,
   68,   90,  116,  199,  132,   17,  180,  150,  148,  104,
  191,  168,  156,  648,  295,  680,  404,  199,  378,  247,
  407,   76,  394,  279,  539,  544,  377,  413,  542,  568,
  564,  498,    0,  393,  574,  642,    0,  399,
};
short yycheck[] = {                                       1,
    2,   40,  376,    5,    6,  124,  125,  126,   41,  128,
  129,  130,  131,  148,   41,  150,  151,   59,   41,  125,
  370,  374,  372,  384,  165,  166,  372,  146,  296,  368,
  123,  366,   59,  368,  153,  370,  397,  372,  123,  257,
  258,  259,  260,  261,   59,  278,  279,  349,  350,  123,
  257,  258,  278,  279,  261,  305,  306,  307,  308,  123,
  362,  361,  362,  363,  123,  298,  299,  300,  361,   40,
  363,  304,  298,  299,  300,  361,  362,  310,  304,  325,
  326,  349,  350,   40,  310,  424,  572,  573,  462,  424,
   40,  441,  325,  326,  362,  441,  304,   59,   40,  325,
  326,   40,   40,   40,  457,   40,  441,  325,  110,  111,
  112,  337,   40,  339,  340,  341,  257,  258,   40,  121,
  122,  263,  264,  265,  266,  267,  268,  269,  270,  271,
   40,   40,  274,  135,  136,  496,  497,  498,   40,  141,
  142,   40,   40,   40,  505,   40,   40,  497,  498,   40,
   40,   40,   40,  278,  279,  262,  263,  264,  265,  266,
  267,  268,  269,  270,   40,   40,  273,   40,   40,  171,
  172,  173,  174,  298,  299,  300,   40,  179,   40,  304,
  182,  183,  184,  185,   40,  310,   40,   40,  190,  191,
   40,   40,   40,   40,  319,  320,  321,   40,  304,   40,
  325,  326,   40,   40,   40,   40,  278,  279,  125,   40,
   40,  572,  573,   59,   40,  123,   40,   40,   40,   40,
   40,  125,  261,   40,   40,   59,  298,  299,  300,   40,
   40,   40,  304,   40,   59,  274,   40,  363,  310,  125,
  125,  362,  362,  362,  362,  362,  248,  249,  362,  362,
  252,  253,  254,  325,  326,   40,   40,  362,  362,  331,
  362,  333,  334,  335,  336,  337,  338,  339,  340,  341,
  342,  362,  362,  280,  362,  362,  362,   40,  362,  362,
  362,  288,  362,  362,   40,   40,  288,  289,  290,  291,
   40,   40,  278,  279,  301,  302,  303,  304,   41,   40,
   40,   40,  309,  310,   40,  344,  345,  346,  347,  348,
  317,   40,  298,  299,  300,   40,   40,   40,  304,   41,
  327,   41,  364,  365,  310,   41,   41,  366,   41,   41,
   41,  364,  365,   41,   41,   41,   41,  364,  361,  325,
  326,   41,   41,   41,   41,  331,   41,  333,  334,  335,
  336,  337,  338,  339,  340,  341,   41,  280,   41,  361,
   41,   41,   41,  361,   41,  288,   41,   41,   41,   41,
   41,   41,   41,   41,   41,   41,   41,   41,  301,  302,
  303,  304,   41,   41,   41,   41,  309,  310,  523,  524,
   41,   41,   41,  512,   41,   41,   40,  125,   40,  125,
  535,  536,  521,  522,  327,  540,  541,  526,   41,  528,
   41,   59,  531,   41,   41,   41,   41,   41,   41,   41,
  555,  556,   41,  558,  559,   41,  545,   41,   41,   41,
  565,  566,   41,   41,  553,  554,  361,   41,   41,  360,
   41,   41,   41,  562,  276,  277,  278,  279,  280,  281,
  282,  283,  284,  285,  286,  287,  288,  289,  290,  291,
  292,  293,  294,  295,  365,   41,  298,  299,  300,  301,
  302,   41,   41,  272,   41,   41,   41,   41,   59,  311,
  312,  313,  314,  315,  361,   41,  318,  319,  320,  321,
  322,  323,  324,   41,   40,   40,   40,   40,   40,   40,
   40,   40,   40,   40,   40,   40,   40,   40,   40,   40,
   40,  343,   40,  515,   40,   40,  518,   40,   40,   40,
   40,   40,  354,  355,   40,   40,   40,   40,   40,   40,
   40,  533,  534,   40,   40,   40,   40,   40,   40,   40,
   40,  543,   40,   40,   40,   40,  548,  280,   40,   40,
  552,   40,   40,   40,   40,  288,   40,  362,  361,  561,
  362,  362,  697,  698,  699,  700,  701,  702,  301,  302,
  303,  304,  362,  362,  362,  362,  309,  310,  316,  362,
  362,  362,  362,  362,  703,  362,  362,  362,  362,  362,
  362,  362,   41,   41,  327,   41,  329,  330,  331,  332,
  333,  334,  280,  336,  337,  338,  339,  340,  341,   41,
  288,   41,   41,   41,   41,   41,   41,   41,   41,   41,
   41,   41,   41,  301,  302,  303,  304,   41,   41,   41,
   41,  309,  310,   41,   41,   41,   41,   41,   41,  317,
   41,  319,  320,  321,   41,  280,   41,   41,   41,  327,
   41,  329,  330,  288,   41,   41,   41,   41,   41,  337,
   41,  339,  340,  341,   41,   41,  301,  302,  303,  304,
   41,   41,   41,   41,  309,  310,   41,   41,   41,   41,
   41,   41,   41,   40,  275,   40,   40,  278,  279,   40,
   40,   40,  327,   40,  696,   40,  331,  332,  333,  334,
   41,  336,  337,  338,  339,  340,  341,  298,  299,  300,
   41,   41,   41,  304,   41,   41,   41,   41,    0,  310,
   41,   41,   41,  125,   41,  125,  317,  318,  319,  320,
  321,  322,  323,  324,  325,  326,  125,  328,   41,   41,
   41,   41,   41,  125,   41,  125,   41,   41,   41,   41,
   41,   41,   41,  580,  193,  613,  350,  115,  276,  157,
  353,   24,  291,  181,  457,  468,  275,  364,  462,  496,
  489,  388,   -1,  290,  505,  573,   -1,  304,
};
#define YYFINAL 7
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 366
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,"'('","')'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"';'",0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'{'",0,"'}'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"KW_SOURCE",
"KW_DESTINATION","KW_LOG","KW_OPTIONS","KW_FILTER","KW_INTERNAL","KW_FILE",
"KW_PIPE","KW_UNIX_STREAM","KW_UNIX_DGRAM","KW_TCP","KW_UDP","KW_TCP6",
"KW_UDP6","KW_USER","KW_DOOR","KW_SUN_STREAMS","KW_PROGRAM","KW_FSYNC",
"KW_MARK_FREQ","KW_STATS_FREQ","KW_FLUSH_LINES","KW_FLUSH_TIMEOUT",
"KW_LOG_MSG_SIZE","KW_FILE_TEMPLATE","KW_PROTO_TEMPLATE","KW_CHAIN_HOSTNAMES",
"KW_NORMALIZE_HOSTNAMES","KW_KEEP_HOSTNAME","KW_CHECK_HOSTNAME",
"KW_BAD_HOSTNAME","KW_KEEP_TIMESTAMP","KW_USE_DNS","KW_USE_FQDN","KW_DNS_CACHE",
"KW_DNS_CACHE_SIZE","KW_DNS_CACHE_EXPIRE","KW_DNS_CACHE_EXPIRE_FAILED",
"KW_DNS_CACHE_HOSTS","KW_PERSIST_ONLY","KW_TZ_CONVERT","KW_TS_FORMAT",
"KW_FRAC_DIGITS","KW_LOG_FIFO_SIZE","KW_LOG_FETCH_LIMIT","KW_LOG_IW_SIZE",
"KW_LOG_PREFIX","KW_FLAGS","KW_CATCHALL","KW_FALLBACK","KW_FINAL",
"KW_FLOW_CONTROL","KW_PAD_SIZE","KW_TIME_ZONE","KW_RECV_TIME_ZONE",
"KW_SEND_TIME_ZONE","KW_TIME_REOPEN","KW_TIME_REAP","KW_TIME_SLEEP",
"KW_TMPL_ESCAPE","KW_OPTIONAL","KW_CREATE_DIRS","KW_OWNER","KW_GROUP","KW_PERM",
"KW_DIR_OWNER","KW_DIR_GROUP","KW_DIR_PERM","KW_TEMPLATE","KW_TEMPLATE_ESCAPE",
"KW_FOLLOW_FREQ","KW_OVERWRITE_IF_OLDER","KW_KEEP_ALIVE","KW_MAX_CONNECTIONS",
"KW_LOCALIP","KW_IP","KW_LOCALPORT","KW_PORT","KW_DESTPORT","KW_IP_TTL",
"KW_SO_BROADCAST","KW_IP_TOS","KW_SO_SNDBUF","KW_SO_RCVBUF","KW_SO_KEEPALIVE",
"KW_SPOOF_SOURCE","KW_USE_TIME_RECVD","KW_FACILITY","KW_LEVEL","KW_HOST",
"KW_MATCH","KW_NETMASK","KW_YES","KW_NO","KW_REQUIRED","KW_ALLOW","KW_DENY",
"KW_GC_IDLE_THRESHOLD","KW_GC_BUSY_THRESHOLD","KW_COMPRESS","KW_MAC","KW_AUTH",
"KW_ENCRYPT","DOTDOT","IDENTIFIER","NUMBER","STRING","KW_OR","KW_AND","KW_NOT",
};
char *yyrule[] = {
"$accept : start",
"start : stmts",
"stmts : stmt ';' stmts",
"stmts :",
"stmt : KW_SOURCE source_stmt",
"stmt : KW_DESTINATION dest_stmt",
"stmt : KW_LOG log_stmt",
"stmt : KW_FILTER filter_stmt",
"stmt : KW_TEMPLATE template_stmt",
"stmt : KW_OPTIONS options_stmt",
"source_stmt : string '{' source_items '}'",
"dest_stmt : string '{' dest_items '}'",
"log_stmt : '{' log_items log_flags '}'",
"options_stmt : '{' options_items '}'",
"$$1 :",
"template_stmt : string $$1 '{' template_items '}'",
"template_items : template_item ';' template_items",
"template_items :",
"template_item : KW_TEMPLATE '(' string ')'",
"template_item : KW_TEMPLATE_ESCAPE '(' yesno ')'",
"socket_option : KW_SO_SNDBUF '(' NUMBER ')'",
"socket_option : KW_SO_RCVBUF '(' NUMBER ')'",
"socket_option : KW_SO_BROADCAST '(' yesno ')'",
"socket_option : KW_SO_KEEPALIVE '(' yesno ')'",
"inet_socket_option : socket_option",
"inet_socket_option : KW_IP_TTL '(' NUMBER ')'",
"inet_socket_option : KW_IP_TOS '(' NUMBER ')'",
"source_items : source_item ';' source_items",
"source_items :",
"source_item : source_afinter",
"source_item : source_affile",
"source_item : source_afsocket",
"source_item : source_afstreams",
"source_afinter : KW_INTERNAL '(' ')'",
"source_affile : KW_FILE '(' source_affile_params ')'",
"source_affile : KW_PIPE '(' source_afpipe_params ')'",
"$$2 :",
"source_affile_params : string $$2 source_reader_options",
"$$3 :",
"source_afpipe_params : string $$3 source_afpipe_options",
"source_afpipe_options : KW_OPTIONAL '(' yesno ')'",
"source_afpipe_options : source_reader_options",
"source_afsocket : KW_UNIX_DGRAM '(' source_afunix_dgram_params ')'",
"source_afsocket : KW_UNIX_STREAM '(' source_afunix_stream_params ')'",
"$$4 :",
"source_afsocket : KW_UDP $$4 '(' source_afinet_udp_params ')'",
"$$5 :",
"source_afsocket : KW_TCP $$5 '(' source_afinet_tcp_params ')'",
"$$6 :",
"source_afsocket : KW_UDP6 $$6 '(' source_afinet_udp_params ')'",
"$$7 :",
"source_afsocket : KW_TCP6 $$7 '(' source_afinet_tcp_params ')'",
"$$8 :",
"source_afunix_dgram_params : string $$8 source_afunix_options",
"$$9 :",
"source_afunix_stream_params : string $$9 source_afunix_options",
"source_afunix_options : source_afunix_option source_afunix_options",
"source_afunix_options :",
"source_afunix_option : KW_OWNER '(' string_or_number ')'",
"source_afunix_option : KW_GROUP '(' string_or_number ')'",
"source_afunix_option : KW_PERM '(' NUMBER ')'",
"source_afunix_option : KW_OPTIONAL '(' yesno ')'",
"source_afunix_option : source_afsocket_stream_params",
"source_afunix_option : source_reader_option",
"source_afunix_option : socket_option",
"$$10 :",
"source_afinet_udp_params : $$10 source_afinet_udp_options",
"source_afinet_udp_options : source_afinet_udp_option source_afinet_udp_options",
"source_afinet_udp_options :",
"source_afinet_udp_option : source_afinet_option",
"source_afinet_udp_option : KW_LOCALPORT '(' string_or_number ')'",
"source_afinet_udp_option : KW_PORT '(' string_or_number ')'",
"source_afinet_option : KW_LOCALIP '(' string ')'",
"source_afinet_option : KW_IP '(' string ')'",
"source_afinet_option : source_reader_option",
"source_afinet_option : inet_socket_option",
"$$11 :",
"source_afinet_tcp_params : $$11 source_afinet_tcp_options",
"source_afinet_tcp_options : source_afinet_tcp_option source_afinet_tcp_options",
"source_afinet_tcp_options :",
"source_afinet_tcp_option : source_afinet_option",
"source_afinet_tcp_option : KW_LOCALPORT '(' string_or_number ')'",
"source_afinet_tcp_option : KW_PORT '(' string_or_number ')'",
"source_afinet_tcp_option : source_afsocket_stream_params",
"source_afsocket_stream_params : KW_KEEP_ALIVE '(' yesno ')'",
"source_afsocket_stream_params : KW_MAX_CONNECTIONS '(' NUMBER ')'",
"source_afstreams : KW_SUN_STREAMS '(' source_afstreams_params ')'",
"$$12 :",
"source_afstreams_params : string $$12 source_afstreams_options",
"source_afstreams_options : source_afstreams_option source_afstreams_options",
"source_afstreams_options :",
"source_afstreams_option : KW_DOOR '(' string ')'",
"source_reader_options : source_reader_option source_reader_options",
"source_reader_options :",
"source_reader_option : KW_FLAGS '(' source_reader_option_flags ')'",
"source_reader_option : KW_LOG_MSG_SIZE '(' NUMBER ')'",
"source_reader_option : KW_LOG_IW_SIZE '(' NUMBER ')'",
"source_reader_option : KW_LOG_FETCH_LIMIT '(' NUMBER ')'",
"source_reader_option : KW_LOG_PREFIX '(' string ')'",
"source_reader_option : KW_PAD_SIZE '(' NUMBER ')'",
"source_reader_option : KW_FOLLOW_FREQ '(' NUMBER ')'",
"source_reader_option : KW_TIME_ZONE '(' string ')'",
"source_reader_option : KW_KEEP_TIMESTAMP '(' yesno ')'",
"source_reader_option_flags : IDENTIFIER source_reader_option_flags",
"source_reader_option_flags :",
"dest_items : dest_item ';' dest_items",
"dest_items :",
"dest_item : dest_affile",
"dest_item : dest_afpipe",
"dest_item : dest_afsocket",
"dest_item : dest_afuser",
"dest_item : dest_afprogram",
"dest_affile : KW_FILE '(' dest_affile_params ')'",
"$$13 :",
"dest_affile_params : string $$13 dest_affile_options",
"dest_affile_options : dest_affile_option dest_affile_options",
"dest_affile_options :",
"dest_affile_option : dest_writer_option",
"dest_affile_option : KW_OPTIONAL '(' yesno ')'",
"dest_affile_option : KW_OWNER '(' string_or_number ')'",
"dest_affile_option : KW_GROUP '(' string_or_number ')'",
"dest_affile_option : KW_PERM '(' NUMBER ')'",
"dest_affile_option : KW_DIR_OWNER '(' string_or_number ')'",
"dest_affile_option : KW_DIR_GROUP '(' string_or_number ')'",
"dest_affile_option : KW_DIR_PERM '(' NUMBER ')'",
"dest_affile_option : KW_CREATE_DIRS '(' yesno ')'",
"dest_affile_option : KW_OVERWRITE_IF_OLDER '(' NUMBER ')'",
"dest_affile_option : KW_FSYNC '(' yesno ')'",
"dest_afpipe : KW_PIPE '(' dest_afpipe_params ')'",
"$$14 :",
"dest_afpipe_params : string $$14 dest_afpipe_options",
"dest_afpipe_options : dest_afpipe_option dest_afpipe_options",
"dest_afpipe_options :",
"dest_afpipe_option : dest_writer_option",
"dest_afpipe_option : KW_OWNER '(' string_or_number ')'",
"dest_afpipe_option : KW_GROUP '(' string_or_number ')'",
"dest_afpipe_option : KW_PERM '(' NUMBER ')'",
"dest_afsocket : KW_UNIX_DGRAM '(' dest_afunix_dgram_params ')'",
"dest_afsocket : KW_UNIX_STREAM '(' dest_afunix_stream_params ')'",
"$$15 :",
"dest_afsocket : KW_UDP $$15 '(' dest_afinet_udp_params ')'",
"$$16 :",
"dest_afsocket : KW_TCP $$16 '(' dest_afinet_tcp_params ')'",
"$$17 :",
"dest_afsocket : KW_UDP6 $$17 '(' dest_afinet_udp_params ')'",
"$$18 :",
"dest_afsocket : KW_TCP6 $$18 '(' dest_afinet_tcp_params ')'",
"$$19 :",
"dest_afunix_dgram_params : string $$19 dest_afunix_options",
"$$20 :",
"dest_afunix_stream_params : string $$20 dest_afunix_options",
"dest_afunix_options : dest_afunix_options dest_afunix_option",
"dest_afunix_options :",
"dest_afunix_option : dest_writer_option",
"dest_afunix_option : socket_option",
"$$21 :",
"dest_afinet_udp_params : string $$21 dest_afinet_udp_options",
"dest_afinet_udp_options : dest_afinet_udp_options dest_afinet_udp_option",
"dest_afinet_udp_options :",
"dest_afinet_option : KW_LOCALIP '(' string ')'",
"dest_afinet_option : inet_socket_option",
"dest_afinet_option : dest_writer_option",
"dest_afinet_udp_option : dest_afinet_option",
"dest_afinet_udp_option : KW_LOCALPORT '(' string_or_number ')'",
"dest_afinet_udp_option : KW_PORT '(' string_or_number ')'",
"dest_afinet_udp_option : KW_DESTPORT '(' string_or_number ')'",
"dest_afinet_udp_option : KW_SPOOF_SOURCE '(' yesno ')'",
"$$22 :",
"dest_afinet_tcp_params : string $$22 dest_afinet_tcp_options",
"dest_afinet_tcp_options : dest_afinet_tcp_options dest_afinet_tcp_option",
"dest_afinet_tcp_options :",
"dest_afinet_tcp_option : dest_afinet_option",
"dest_afinet_tcp_option : KW_LOCALPORT '(' string_or_number ')'",
"dest_afinet_tcp_option : KW_PORT '(' string_or_number ')'",
"dest_afinet_tcp_option : KW_DESTPORT '(' string_or_number ')'",
"dest_afuser : KW_USER '(' string ')'",
"dest_afprogram : KW_PROGRAM '(' dest_afprogram_params ')'",
"$$23 :",
"dest_afprogram_params : string $$23 dest_writer_options",
"dest_writer_options : dest_writer_option dest_writer_options",
"dest_writer_options :",
"dest_writer_option : KW_FLAGS '(' dest_writer_options_flags ')'",
"dest_writer_option : KW_LOG_FIFO_SIZE '(' NUMBER ')'",
"dest_writer_option : KW_FLUSH_LINES '(' NUMBER ')'",
"dest_writer_option : KW_FLUSH_TIMEOUT '(' NUMBER ')'",
"dest_writer_option : KW_TEMPLATE '(' string ')'",
"dest_writer_option : KW_TEMPLATE_ESCAPE '(' yesno ')'",
"dest_writer_option : KW_TIME_ZONE '(' string ')'",
"dest_writer_option : KW_TS_FORMAT '(' string ')'",
"dest_writer_option : KW_FRAC_DIGITS '(' NUMBER ')'",
"dest_writer_options_flags : dest_writer_options_flag dest_writer_options_flags",
"dest_writer_options_flags :",
"dest_writer_options_flag : KW_TMPL_ESCAPE",
"log_items : log_item ';' log_items",
"log_items :",
"log_item : KW_SOURCE '(' string ')'",
"log_item : KW_FILTER '(' string ')'",
"log_item : KW_DESTINATION '(' string ')'",
"log_flags : KW_FLAGS '(' log_flags_items ')' ';'",
"log_flags :",
"log_flags_items : log_flags_item log_flags_items",
"log_flags_items :",
"log_flags_item : KW_CATCHALL",
"log_flags_item : KW_FALLBACK",
"log_flags_item : KW_FINAL",
"log_flags_item : KW_FLOW_CONTROL",
"options_items : options_item ';' options_items",
"options_items :",
"options_item : KW_MARK_FREQ '(' NUMBER ')'",
"options_item : KW_STATS_FREQ '(' NUMBER ')'",
"options_item : KW_FLUSH_LINES '(' NUMBER ')'",
"options_item : KW_FLUSH_TIMEOUT '(' NUMBER ')'",
"options_item : KW_CHAIN_HOSTNAMES '(' yesno ')'",
"options_item : KW_NORMALIZE_HOSTNAMES '(' yesno ')'",
"options_item : KW_KEEP_HOSTNAME '(' yesno ')'",
"options_item : KW_CHECK_HOSTNAME '(' yesno ')'",
"options_item : KW_BAD_HOSTNAME '(' STRING ')'",
"options_item : KW_USE_TIME_RECVD '(' yesno ')'",
"options_item : KW_USE_FQDN '(' yesno ')'",
"options_item : KW_USE_DNS '(' dnsmode ')'",
"options_item : KW_TIME_REOPEN '(' NUMBER ')'",
"options_item : KW_TIME_REAP '(' NUMBER ')'",
"options_item : KW_TIME_SLEEP '(' NUMBER ')'",
"options_item : KW_LOG_FIFO_SIZE '(' NUMBER ')'",
"options_item : KW_LOG_IW_SIZE '(' NUMBER ')'",
"options_item : KW_LOG_FETCH_LIMIT '(' NUMBER ')'",
"options_item : KW_LOG_MSG_SIZE '(' NUMBER ')'",
"options_item : KW_KEEP_TIMESTAMP '(' yesno ')'",
"options_item : KW_TS_FORMAT '(' string ')'",
"options_item : KW_FRAC_DIGITS '(' NUMBER ')'",
"options_item : KW_GC_BUSY_THRESHOLD '(' NUMBER ')'",
"options_item : KW_GC_IDLE_THRESHOLD '(' NUMBER ')'",
"options_item : KW_CREATE_DIRS '(' yesno ')'",
"options_item : KW_OWNER '(' string_or_number ')'",
"options_item : KW_GROUP '(' string_or_number ')'",
"options_item : KW_PERM '(' NUMBER ')'",
"options_item : KW_DIR_OWNER '(' string_or_number ')'",
"options_item : KW_DIR_GROUP '(' string_or_number ')'",
"options_item : KW_DIR_PERM '(' NUMBER ')'",
"options_item : KW_DNS_CACHE '(' yesno ')'",
"options_item : KW_DNS_CACHE_SIZE '(' NUMBER ')'",
"options_item : KW_DNS_CACHE_EXPIRE '(' NUMBER ')'",
"options_item : KW_DNS_CACHE_EXPIRE_FAILED '(' NUMBER ')'",
"options_item : KW_DNS_CACHE_HOSTS '(' string ')'",
"options_item : KW_FILE_TEMPLATE '(' string ')'",
"options_item : KW_PROTO_TEMPLATE '(' string ')'",
"options_item : KW_RECV_TIME_ZONE '(' string ')'",
"options_item : KW_SEND_TIME_ZONE '(' string ')'",
"filter_stmt : string '{' filter_expr ';' '}'",
"filter_expr : filter_simple_expr",
"filter_expr : KW_NOT filter_expr",
"filter_expr : filter_expr KW_OR filter_expr",
"filter_expr : filter_expr KW_AND filter_expr",
"filter_expr : '(' filter_expr ')'",
"filter_simple_expr : KW_FACILITY '(' filter_fac_list ')'",
"filter_simple_expr : KW_FACILITY '(' NUMBER ')'",
"filter_simple_expr : KW_LEVEL '(' filter_level_list ')'",
"filter_simple_expr : KW_PROGRAM '(' string ')'",
"filter_simple_expr : KW_HOST '(' string ')'",
"filter_simple_expr : KW_MATCH '(' string ')'",
"filter_simple_expr : KW_FILTER '(' string ')'",
"filter_simple_expr : KW_NETMASK '(' string ')'",
"filter_fac_list : filter_fac filter_fac_list",
"filter_fac_list : filter_fac",
"filter_fac : IDENTIFIER",
"filter_level_list : filter_level filter_level_list",
"filter_level_list : filter_level",
"filter_level : IDENTIFIER DOTDOT IDENTIFIER",
"filter_level : IDENTIFIER",
"yesno : KW_YES",
"yesno : KW_NO",
"yesno : NUMBER",
"dnsmode : yesno",
"dnsmode : KW_PERSIST_ONLY",
"string : IDENTIFIER",
"string : STRING",
"string_or_number : string",
"string_or_number : NUMBER",
};
#endif
#if YYDEBUG
#include <stdio.h>
#endif

/* define the initial stack-sizes */
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH  YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH  500
#endif
#endif

#define YYINITSTACKSIZE 500

int      yydebug;
int      yynerrs;
int      yyerrflag;
int      yychar;
short   *yyssp;
YYSTYPE *yyvsp;
YYSTYPE  yyval;
YYSTYPE  yylval;

/* variables for the parser stack */
static short   *yyss;
static short   *yysslim;
static YYSTYPE *yyvs;
static int      yystacksize;
#line 894 "cfg-grammar.y"

extern int linenum;

void 
yyerror(char *msg)
{
  fprintf(stderr, "%s at %d\n", msg, linenum);
}

void
yyparser_reset(void)
{
  last_driver = NULL;
  last_reader_options = NULL;
  last_writer_options = NULL;
  last_template = NULL;
}
#line 1025 "cfg-grammar.c"
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack(void)
{
    int newsize, i;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = yystacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;

    i = yyssp - yyss;
    newss = (yyss != 0)
          ? (short *)realloc(yyss, newsize * sizeof(*newss))
          : (short *)malloc(newsize * sizeof(*newss));
    if (newss == 0)
        return -1;

    yyss  = newss;
    yyssp = newss + i;
    newvs = (yyvs != 0)
          ? (YYSTYPE *)realloc(yyvs, newsize * sizeof(*newvs))
          : (YYSTYPE *)malloc(newsize * sizeof(*newvs));
    if (newvs == 0)
        return -1;

    yyvs = newvs;
    yyvsp = newvs + i;
    yystacksize = newsize;
    yysslim = yyss + newsize - 1;
    return 0;
}

#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse(void)
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register const char *yys;

    if ((yys = getenv("YYDEBUG")) != 0)
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = YYEMPTY;

    if (yyss == NULL && yygrowstack()) goto yyoverflow;
    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yysslim && yygrowstack())
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = YYEMPTY;
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;

    yyerror("syntax error");

#ifdef lint
    goto yyerrlab;
#endif

yyerrlab:
    ++yynerrs;

yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yysslim && yygrowstack())
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = YYEMPTY;
        goto yyloop;
    }

yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 4:
#line 206 "cfg-grammar.y"
{ cfg_add_source(configuration, yyvsp[0].ptr); }
break;
case 5:
#line 207 "cfg-grammar.y"
{ cfg_add_dest(configuration, yyvsp[0].ptr); }
break;
case 6:
#line 208 "cfg-grammar.y"
{ cfg_add_connection(configuration, yyvsp[0].ptr); }
break;
case 7:
#line 209 "cfg-grammar.y"
{ cfg_add_filter(configuration, yyvsp[0].ptr); }
break;
case 8:
#line 210 "cfg-grammar.y"
{ cfg_add_template(configuration, yyvsp[0].ptr); }
break;
case 9:
#line 211 "cfg-grammar.y"
{  }
break;
case 10:
#line 215 "cfg-grammar.y"
{ yyval.ptr = log_source_group_new(yyvsp[-3].cptr, yyvsp[-1].ptr); free(yyvsp[-3].cptr); }
break;
case 11:
#line 219 "cfg-grammar.y"
{ yyval.ptr = log_dest_group_new(yyvsp[-3].cptr, yyvsp[-1].ptr); free(yyvsp[-3].cptr); }
break;
case 12:
#line 223 "cfg-grammar.y"
{ yyval.ptr = log_connection_new(yyvsp[-2].ptr, yyvsp[-1].num); }
break;
case 13:
#line 227 "cfg-grammar.y"
{ yyval.ptr = NULL; }
break;
case 14:
#line 232 "cfg-grammar.y"
{
	    last_template = log_template_new(yyvsp[0].cptr, NULL);
	    free(yyvsp[0].cptr);
	  }
break;
case 15:
#line 236 "cfg-grammar.y"
{ yyval.ptr = last_template;  }
break;
case 18:
#line 245 "cfg-grammar.y"
{ last_template->template = g_string_new(yyvsp[-1].cptr); free(yyvsp[-1].cptr); }
break;
case 19:
#line 246 "cfg-grammar.y"
{ log_template_set_escape(last_template, yyvsp[-1].num); }
break;
case 20:
#line 250 "cfg-grammar.y"
{ last_sock_options->sndbuf = yyvsp[-1].num; }
break;
case 21:
#line 251 "cfg-grammar.y"
{ last_sock_options->rcvbuf = yyvsp[-1].num; }
break;
case 22:
#line 252 "cfg-grammar.y"
{ last_sock_options->broadcast = yyvsp[-1].num; }
break;
case 23:
#line 253 "cfg-grammar.y"
{ last_sock_options->keepalive = yyvsp[-1].num; }
break;
case 25:
#line 258 "cfg-grammar.y"
{ ((InetSocketOptions *) last_sock_options)->ttl = yyvsp[-1].num; }
break;
case 26:
#line 259 "cfg-grammar.y"
{ ((InetSocketOptions *) last_sock_options)->tos = yyvsp[-1].num; }
break;
case 27:
#line 263 "cfg-grammar.y"
{ log_drv_append(yyvsp[-2].ptr, yyvsp[0].ptr); log_drv_unref(yyvsp[0].ptr); yyval.ptr = yyvsp[-2].ptr; }
break;
case 28:
#line 264 "cfg-grammar.y"
{ yyval.ptr = NULL; }
break;
case 29:
#line 268 "cfg-grammar.y"
{ yyval.ptr = yyvsp[0].ptr; }
break;
case 30:
#line 269 "cfg-grammar.y"
{ yyval.ptr = yyvsp[0].ptr; }
break;
case 31:
#line 270 "cfg-grammar.y"
{ yyval.ptr = yyvsp[0].ptr; }
break;
case 32:
#line 271 "cfg-grammar.y"
{ yyval.ptr = yyvsp[0].ptr; }
break;
case 33:
#line 275 "cfg-grammar.y"
{ yyval.ptr = afinter_sd_new(); }
break;
case 34:
#line 279 "cfg-grammar.y"
{ yyval.ptr = yyvsp[-1].ptr; }
break;
case 35:
#line 280 "cfg-grammar.y"
{ yyval.ptr = yyvsp[-1].ptr; }
break;
case 36:
#line 285 "cfg-grammar.y"
{
	    last_driver = affile_sd_new(yyvsp[0].cptr, 0); 
	    free(yyvsp[0].cptr); 
	    last_reader_options = &((AFFileSourceDriver *) last_driver)->reader_options;
	  }
break;
case 37:
#line 290 "cfg-grammar.y"
{ yyval.ptr = last_driver; }
break;
case 38:
#line 295 "cfg-grammar.y"
{
	    last_driver = affile_sd_new(yyvsp[0].cptr, AFFILE_PIPE); 
	    free(yyvsp[0].cptr); 
	    last_reader_options = &((AFFileSourceDriver *) last_driver)->reader_options;
	  }
break;
case 39:
#line 300 "cfg-grammar.y"
{ yyval.ptr = last_driver; }
break;
case 40:
#line 304 "cfg-grammar.y"
{ last_driver->optional = yyvsp[-1].num; }
break;
case 41:
#line 305 "cfg-grammar.y"
{}
break;
case 42:
#line 309 "cfg-grammar.y"
{ yyval.ptr = yyvsp[-1].ptr; }
break;
case 43:
#line 310 "cfg-grammar.y"
{ yyval.ptr = yyvsp[-1].ptr; }
break;
case 44:
#line 311 "cfg-grammar.y"
{ last_addr_family = AF_INET; }
break;
case 45:
#line 311 "cfg-grammar.y"
{ yyval.ptr = yyvsp[-1].ptr; }
break;
case 46:
#line 312 "cfg-grammar.y"
{ last_addr_family = AF_INET; }
break;
case 47:
#line 312 "cfg-grammar.y"
{ yyval.ptr = yyvsp[-1].ptr; }
break;
case 48:
#line 313 "cfg-grammar.y"
{ last_addr_family = AF_INET6; }
break;
case 49:
#line 313 "cfg-grammar.y"
{ yyval.ptr = yyvsp[-1].ptr; }
break;
case 50:
#line 314 "cfg-grammar.y"
{ last_addr_family = AF_INET6; }
break;
case 51:
#line 314 "cfg-grammar.y"
{ yyval.ptr = yyvsp[-1].ptr; }
break;
case 52:
#line 319 "cfg-grammar.y"
{ 
	    last_driver = afunix_sd_new(
		yyvsp[0].cptr,
		AFSOCKET_DGRAM | AFSOCKET_LOCAL); 
	    free(yyvsp[0].cptr); 
	    last_reader_options = &((AFSocketSourceDriver *) last_driver)->reader_options;
	    last_sock_options = &((AFUnixSourceDriver *) last_driver)->sock_options;
	  }
break;
case 53:
#line 327 "cfg-grammar.y"
{ yyval.ptr = last_driver; }
break;
case 54:
#line 332 "cfg-grammar.y"
{ 
	    last_driver = afunix_sd_new(
		yyvsp[0].cptr,
		AFSOCKET_STREAM | AFSOCKET_KEEP_ALIVE | AFSOCKET_LOCAL);
	    free(yyvsp[0].cptr);
	    last_reader_options = &((AFSocketSourceDriver *) last_driver)->reader_options;
	    last_sock_options = &((AFUnixSourceDriver *) last_driver)->sock_options;
	  }
break;
case 55:
#line 340 "cfg-grammar.y"
{ yyval.ptr = last_driver; }
break;
case 58:
#line 350 "cfg-grammar.y"
{ afunix_sd_set_uid(last_driver, yyvsp[-1].cptr); free(yyvsp[-1].cptr); }
break;
case 59:
#line 351 "cfg-grammar.y"
{ afunix_sd_set_gid(last_driver, yyvsp[-1].cptr); free(yyvsp[-1].cptr); }
break;
case 60:
#line 352 "cfg-grammar.y"
{ afunix_sd_set_perm(last_driver, yyvsp[-1].num); }
break;
case 61:
#line 353 "cfg-grammar.y"
{ last_driver->optional = yyvsp[-1].num; }
break;
case 62:
#line 354 "cfg-grammar.y"
{}
break;
case 63:
#line 355 "cfg-grammar.y"
{}
break;
case 64:
#line 356 "cfg-grammar.y"
{}
break;
case 65:
#line 361 "cfg-grammar.y"
{ 
	    last_driver = afinet_sd_new(last_addr_family,
			NULL, 514,
			AFSOCKET_DGRAM);
	    last_reader_options = &((AFSocketSourceDriver *) last_driver)->reader_options;
	    last_sock_options = &((AFInetSourceDriver *) last_driver)->sock_options.super;
	  }
break;
case 66:
#line 368 "cfg-grammar.y"
{ yyval.ptr = last_driver; }
break;
case 70:
#line 378 "cfg-grammar.y"
{ afinet_sd_set_localport(last_driver, yyvsp[-1].cptr, "udp"); free(yyvsp[-1].cptr); }
break;
case 71:
#line 379 "cfg-grammar.y"
{ afinet_sd_set_localport(last_driver, yyvsp[-1].cptr, "udp"); free(yyvsp[-1].cptr); }
break;
case 72:
#line 383 "cfg-grammar.y"
{ afinet_sd_set_localip(last_driver, yyvsp[-1].cptr); free(yyvsp[-1].cptr); }
break;
case 73:
#line 384 "cfg-grammar.y"
{ afinet_sd_set_localip(last_driver, yyvsp[-1].cptr); free(yyvsp[-1].cptr); }
break;
case 76:
#line 391 "cfg-grammar.y"
{ 
	    last_driver = afinet_sd_new(last_addr_family,
			NULL, 514,
			AFSOCKET_STREAM);
	    last_reader_options = &((AFSocketSourceDriver *) last_driver)->reader_options;
	    last_sock_options = &((AFInetSourceDriver *) last_driver)->sock_options.super;
	  }
break;
case 77:
#line 398 "cfg-grammar.y"
{ yyval.ptr = last_driver; }
break;
case 81:
#line 408 "cfg-grammar.y"
{ afinet_sd_set_localport(last_driver, yyvsp[-1].cptr, "tcp"); free(yyvsp[-1].cptr); }
break;
case 82:
#line 409 "cfg-grammar.y"
{ afinet_sd_set_localport(last_driver, yyvsp[-1].cptr, "tcp"); free(yyvsp[-1].cptr); }
break;
case 83:
#line 410 "cfg-grammar.y"
{}
break;
case 84:
#line 414 "cfg-grammar.y"
{ afsocket_sd_set_keep_alive(last_driver, yyvsp[-1].num); }
break;
case 85:
#line 415 "cfg-grammar.y"
{ afsocket_sd_set_max_connections(last_driver, yyvsp[-1].num); }
break;
case 86:
#line 419 "cfg-grammar.y"
{ yyval.ptr = yyvsp[-1].ptr; }
break;
case 87:
#line 424 "cfg-grammar.y"
{ 
	    last_driver = afstreams_sd_new(yyvsp[0].cptr); 
	    free(yyvsp[0].cptr); 
	  }
break;
case 88:
#line 428 "cfg-grammar.y"
{ yyval.ptr = last_driver; }
break;
case 91:
#line 437 "cfg-grammar.y"
{ afstreams_sd_set_sundoor(last_driver, yyvsp[-1].cptr); free(yyvsp[-1].cptr); }
break;
case 94:
#line 446 "cfg-grammar.y"
{ last_reader_options->options = yyvsp[-1].num; }
break;
case 95:
#line 447 "cfg-grammar.y"
{ last_reader_options->msg_size = yyvsp[-1].num; }
break;
case 96:
#line 448 "cfg-grammar.y"
{ last_reader_options->source_opts.init_window_size = yyvsp[-1].num; }
break;
case 97:
#line 449 "cfg-grammar.y"
{ last_reader_options->fetch_limit = yyvsp[-1].num; }
break;
case 98:
#line 450 "cfg-grammar.y"
{ last_reader_options->prefix = yyvsp[-1].cptr; }
break;
case 99:
#line 451 "cfg-grammar.y"
{ last_reader_options->padding = yyvsp[-1].num; }
break;
case 100:
#line 452 "cfg-grammar.y"
{ last_reader_options->follow_freq = yyvsp[-1].num; }
break;
case 101:
#line 453 "cfg-grammar.y"
{ cfg_timezone_value(yyvsp[-1].cptr, &last_reader_options->zone_offset); free(yyvsp[-1].cptr); }
break;
case 102:
#line 454 "cfg-grammar.y"
{ last_reader_options->keep_timestamp = yyvsp[-1].num; }
break;
case 103:
#line 458 "cfg-grammar.y"
{ yyval.num = lookup_parse_flag(yyvsp[-1].cptr) | yyvsp[0].num; free(yyvsp[-1].cptr); }
break;
case 104:
#line 459 "cfg-grammar.y"
{ yyval.num = 0; }
break;
case 105:
#line 464 "cfg-grammar.y"
{ log_drv_append(yyvsp[-2].ptr, yyvsp[0].ptr); log_drv_unref(yyvsp[0].ptr); yyval.ptr = yyvsp[-2].ptr; }
break;
case 106:
#line 465 "cfg-grammar.y"
{ yyval.ptr = NULL; }
break;
case 107:
#line 469 "cfg-grammar.y"
{ yyval.ptr = yyvsp[0].ptr; }
break;
case 108:
#line 470 "cfg-grammar.y"
{ yyval.ptr = yyvsp[0].ptr; }
break;
case 109:
#line 471 "cfg-grammar.y"
{ yyval.ptr = yyvsp[0].ptr; }
break;
case 110:
#line 472 "cfg-grammar.y"
{ yyval.ptr = yyvsp[0].ptr; }
break;
case 111:
#line 473 "cfg-grammar.y"
{ yyval.ptr = yyvsp[0].ptr; }
break;
case 112:
#line 477 "cfg-grammar.y"
{ yyval.ptr = yyvsp[-1].ptr; }
break;
case 113:
#line 482 "cfg-grammar.y"
{ 
	    last_driver = affile_dd_new(yyvsp[0].cptr, 0); 
	    free(yyvsp[0].cptr); 
	    last_writer_options = &((AFFileDestDriver *) last_driver)->writer_options;
	  }
break;
case 114:
#line 488 "cfg-grammar.y"
{ yyval.ptr = last_driver; }
break;
case 118:
#line 498 "cfg-grammar.y"
{ last_driver->optional = yyvsp[-1].num; }
break;
case 119:
#line 503 "cfg-grammar.y"
{ affile_dd_set_file_uid(last_driver, yyvsp[-1].cptr); free(yyvsp[-1].cptr); }
break;
case 120:
#line 504 "cfg-grammar.y"
{ affile_dd_set_file_gid(last_driver, yyvsp[-1].cptr); free(yyvsp[-1].cptr); }
break;
case 121:
#line 505 "cfg-grammar.y"
{ affile_dd_set_file_perm(last_driver, yyvsp[-1].num); }
break;
case 122:
#line 506 "cfg-grammar.y"
{ affile_dd_set_dir_uid(last_driver, yyvsp[-1].cptr); free(yyvsp[-1].cptr); }
break;
case 123:
#line 507 "cfg-grammar.y"
{ affile_dd_set_dir_gid(last_driver, yyvsp[-1].cptr); free(yyvsp[-1].cptr); }
break;
case 124:
#line 508 "cfg-grammar.y"
{ affile_dd_set_dir_perm(last_driver, yyvsp[-1].num); }
break;
case 125:
#line 509 "cfg-grammar.y"
{ affile_dd_set_create_dirs(last_driver, yyvsp[-1].num); }
break;
case 126:
#line 510 "cfg-grammar.y"
{ affile_dd_set_overwrite_if_older(last_driver, yyvsp[-1].num); }
break;
case 127:
#line 511 "cfg-grammar.y"
{ affile_dd_set_fsync(last_driver, yyvsp[-1].num); }
break;
case 128:
#line 515 "cfg-grammar.y"
{ yyval.ptr = yyvsp[-1].ptr; }
break;
case 129:
#line 520 "cfg-grammar.y"
{ 
	    last_driver = affile_dd_new(yyvsp[0].cptr, AFFILE_NO_EXPAND | AFFILE_PIPE);
	    free(yyvsp[0].cptr); 
	    last_writer_options = &((AFFileDestDriver *) last_driver)->writer_options;
	    last_writer_options->flush_lines = 0;
	  }
break;
case 130:
#line 526 "cfg-grammar.y"
{ yyval.ptr = last_driver; }
break;
case 134:
#line 536 "cfg-grammar.y"
{ affile_dd_set_file_uid(last_driver, yyvsp[-1].cptr); free(yyvsp[-1].cptr); }
break;
case 135:
#line 537 "cfg-grammar.y"
{ affile_dd_set_file_gid(last_driver, yyvsp[-1].cptr); free(yyvsp[-1].cptr); }
break;
case 136:
#line 538 "cfg-grammar.y"
{ affile_dd_set_file_perm(last_driver, yyvsp[-1].num); }
break;
case 137:
#line 543 "cfg-grammar.y"
{ yyval.ptr = yyvsp[-1].ptr; }
break;
case 138:
#line 544 "cfg-grammar.y"
{ yyval.ptr = yyvsp[-1].ptr; }
break;
case 139:
#line 545 "cfg-grammar.y"
{ last_addr_family = AF_INET; }
break;
case 140:
#line 545 "cfg-grammar.y"
{ yyval.ptr = yyvsp[-1].ptr; }
break;
case 141:
#line 546 "cfg-grammar.y"
{ last_addr_family = AF_INET; }
break;
case 142:
#line 546 "cfg-grammar.y"
{ yyval.ptr = yyvsp[-1].ptr; }
break;
case 143:
#line 547 "cfg-grammar.y"
{ last_addr_family = AF_INET6; }
break;
case 144:
#line 547 "cfg-grammar.y"
{ yyval.ptr = yyvsp[-1].ptr; }
break;
case 145:
#line 548 "cfg-grammar.y"
{ last_addr_family = AF_INET6; }
break;
case 146:
#line 548 "cfg-grammar.y"
{ yyval.ptr = yyvsp[-1].ptr; }
break;
case 147:
#line 553 "cfg-grammar.y"
{ 
	    last_driver = afunix_dd_new(yyvsp[0].cptr, AFSOCKET_DGRAM);
	    free(yyvsp[0].cptr);
	    last_writer_options = &((AFSocketDestDriver *) last_driver)->writer_options;
	    last_sock_options = &((AFUnixDestDriver *) last_driver)->sock_options;
	  }
break;
case 148:
#line 559 "cfg-grammar.y"
{ yyval.ptr = last_driver; }
break;
case 149:
#line 564 "cfg-grammar.y"
{ 
	    last_driver = afunix_dd_new(yyvsp[0].cptr, AFSOCKET_STREAM);
	    free(yyvsp[0].cptr);
	    last_writer_options = &((AFSocketDestDriver *) last_driver)->writer_options;
	    last_sock_options = &((AFUnixDestDriver *) last_driver)->sock_options;
	  }
break;
case 150:
#line 570 "cfg-grammar.y"
{ yyval.ptr = last_driver; }
break;
case 155:
#line 585 "cfg-grammar.y"
{ 
	    last_driver = afinet_dd_new(last_addr_family,
			yyvsp[0].cptr, 514,
			AFSOCKET_DGRAM);
	    free(yyvsp[0].cptr);
	    last_writer_options = &((AFSocketDestDriver *) last_driver)->writer_options;
	    last_sock_options = &((AFInetDestDriver *) last_driver)->sock_options.super;
	  }
break;
case 156:
#line 593 "cfg-grammar.y"
{ yyval.ptr = last_driver; }
break;
case 159:
#line 603 "cfg-grammar.y"
{ afinet_dd_set_localip(last_driver, yyvsp[-1].cptr); free(yyvsp[-1].cptr); }
break;
case 163:
#line 610 "cfg-grammar.y"
{ afinet_dd_set_localport(last_driver, yyvsp[-1].cptr, "udp"); free(yyvsp[-1].cptr); }
break;
case 164:
#line 611 "cfg-grammar.y"
{ afinet_dd_set_destport(last_driver, yyvsp[-1].cptr, "udp"); free(yyvsp[-1].cptr); }
break;
case 165:
#line 612 "cfg-grammar.y"
{ afinet_dd_set_destport(last_driver, yyvsp[-1].cptr, "udp"); free(yyvsp[-1].cptr); }
break;
case 166:
#line 613 "cfg-grammar.y"
{ afinet_dd_set_spoof_source(last_driver, yyvsp[-1].num); }
break;
case 167:
#line 618 "cfg-grammar.y"
{ 
	    last_driver = afinet_dd_new(last_addr_family,
			yyvsp[0].cptr, 514,
			AFSOCKET_STREAM); 
	    free(yyvsp[0].cptr);
	    last_writer_options = &((AFSocketDestDriver *) last_driver)->writer_options;
	    last_sock_options = &((AFInetDestDriver *) last_driver)->sock_options.super;
	  }
break;
case 168:
#line 626 "cfg-grammar.y"
{ yyval.ptr = last_driver; }
break;
case 172:
#line 636 "cfg-grammar.y"
{ afinet_dd_set_localport(last_driver, yyvsp[-1].cptr, "tcp"); free(yyvsp[-1].cptr); }
break;
case 173:
#line 637 "cfg-grammar.y"
{ afinet_dd_set_destport(last_driver, yyvsp[-1].cptr, "tcp"); free(yyvsp[-1].cptr); }
break;
case 174:
#line 638 "cfg-grammar.y"
{ afinet_dd_set_destport(last_driver, yyvsp[-1].cptr, "tcp"); free(yyvsp[-1].cptr); }
break;
case 175:
#line 648 "cfg-grammar.y"
{ yyval.ptr = afuser_dd_new(yyvsp[-1].cptr); free(yyvsp[-1].cptr); }
break;
case 176:
#line 652 "cfg-grammar.y"
{ yyval.ptr = yyvsp[-1].ptr; }
break;
case 177:
#line 657 "cfg-grammar.y"
{ 
	    last_driver = afprogram_dd_new(yyvsp[0].cptr); 
	    free(yyvsp[0].cptr); 
	    last_writer_options = &((AFProgramDestDriver *) last_driver)->writer_options;
	  }
break;
case 178:
#line 662 "cfg-grammar.y"
{ yyval.ptr = last_driver; }
break;
case 181:
#line 671 "cfg-grammar.y"
{ last_writer_options->options = yyvsp[-1].num; }
break;
case 182:
#line 672 "cfg-grammar.y"
{ last_writer_options->fifo_size = yyvsp[-1].num; }
break;
case 183:
#line 673 "cfg-grammar.y"
{ last_writer_options->flush_lines = yyvsp[-1].num; }
break;
case 184:
#line 674 "cfg-grammar.y"
{ last_writer_options->flush_timeout = yyvsp[-1].num; }
break;
case 185:
#line 675 "cfg-grammar.y"
{ 
	                                          last_writer_options->template = cfg_lookup_template(configuration, yyvsp[-1].cptr);
	                                          if (last_writer_options->template == NULL)
	                                            {
	                                              last_writer_options->template = log_template_new(NULL, yyvsp[-1].cptr); 
	                                              last_writer_options->template->def_inline = TRUE;
	                                            }
	                                          free(yyvsp[-1].cptr);
	                                        }
break;
case 186:
#line 684 "cfg-grammar.y"
{ log_writer_options_set_template_escape(last_writer_options, yyvsp[-1].num); }
break;
case 187:
#line 685 "cfg-grammar.y"
{ cfg_timezone_value(yyvsp[-1].cptr, &last_writer_options->zone_offset); free(yyvsp[-1].cptr); }
break;
case 188:
#line 686 "cfg-grammar.y"
{ last_writer_options->ts_format = cfg_ts_format_value(yyvsp[-1].cptr); free(yyvsp[-1].cptr); }
break;
case 189:
#line 687 "cfg-grammar.y"
{ last_writer_options->frac_digits = yyvsp[-1].num; }
break;
case 190:
#line 691 "cfg-grammar.y"
{ yyval.num = yyvsp[-1].num | yyvsp[0].num; }
break;
case 191:
#line 692 "cfg-grammar.y"
{ yyval.num = 0; }
break;
case 192:
#line 696 "cfg-grammar.y"
{ yyval.num = LWO_TMPL_ESCAPE; }
break;
case 193:
#line 701 "cfg-grammar.y"
{ log_endpoint_append(yyvsp[-2].ptr, yyvsp[0].ptr); yyval.ptr = yyvsp[-2].ptr; }
break;
case 194:
#line 702 "cfg-grammar.y"
{ yyval.ptr = NULL; }
break;
case 195:
#line 706 "cfg-grammar.y"
{ yyval.ptr = log_endpoint_new(EP_SOURCE, yyvsp[-1].cptr); free(yyvsp[-1].cptr); }
break;
case 196:
#line 707 "cfg-grammar.y"
{ yyval.ptr = log_endpoint_new(EP_FILTER, yyvsp[-1].cptr); free(yyvsp[-1].cptr); }
break;
case 197:
#line 708 "cfg-grammar.y"
{ yyval.ptr = log_endpoint_new(EP_DESTINATION, yyvsp[-1].cptr); free(yyvsp[-1].cptr); }
break;
case 198:
#line 712 "cfg-grammar.y"
{ yyval.num = yyvsp[-2].num; }
break;
case 199:
#line 713 "cfg-grammar.y"
{ yyval.num = 0; }
break;
case 200:
#line 718 "cfg-grammar.y"
{ yyval.num |= yyvsp[0].num; }
break;
case 201:
#line 719 "cfg-grammar.y"
{ yyval.num = 0; }
break;
case 202:
#line 723 "cfg-grammar.y"
{ yyval.num = LC_CATCHALL; }
break;
case 203:
#line 724 "cfg-grammar.y"
{ yyval.num = LC_FALLBACK; }
break;
case 204:
#line 725 "cfg-grammar.y"
{ yyval.num = LC_FINAL; }
break;
case 205:
#line 726 "cfg-grammar.y"
{ yyval.num = LC_FLOW_CONTROL; }
break;
case 206:
#line 730 "cfg-grammar.y"
{ yyval.ptr = yyvsp[-2].ptr; }
break;
case 207:
#line 731 "cfg-grammar.y"
{ yyval.ptr = NULL; }
break;
case 208:
#line 735 "cfg-grammar.y"
{ configuration->mark_freq = yyvsp[-1].num; }
break;
case 209:
#line 736 "cfg-grammar.y"
{ configuration->stats_freq = yyvsp[-1].num; }
break;
case 210:
#line 737 "cfg-grammar.y"
{ configuration->flush_lines = yyvsp[-1].num; }
break;
case 211:
#line 738 "cfg-grammar.y"
{ configuration->flush_timeout = yyvsp[-1].num; }
break;
case 212:
#line 739 "cfg-grammar.y"
{ configuration->chain_hostnames = yyvsp[-1].num; }
break;
case 213:
#line 740 "cfg-grammar.y"
{ configuration->normalize_hostnames = yyvsp[-1].num; }
break;
case 214:
#line 741 "cfg-grammar.y"
{ configuration->keep_hostname = yyvsp[-1].num; }
break;
case 215:
#line 742 "cfg-grammar.y"
{ configuration->check_hostname = yyvsp[-1].num; }
break;
case 216:
#line 743 "cfg-grammar.y"
{ cfg_bad_hostname_set(configuration, yyvsp[-1].cptr); free(yyvsp[-1].cptr); }
break;
case 217:
#line 744 "cfg-grammar.y"
{ configuration->use_time_recvd = yyvsp[-1].num; }
break;
case 218:
#line 745 "cfg-grammar.y"
{ configuration->use_fqdn = yyvsp[-1].num; }
break;
case 219:
#line 746 "cfg-grammar.y"
{ configuration->use_dns = yyvsp[-1].num; }
break;
case 220:
#line 747 "cfg-grammar.y"
{ configuration->time_reopen = yyvsp[-1].num; }
break;
case 221:
#line 748 "cfg-grammar.y"
{ configuration->time_reap = yyvsp[-1].num; }
break;
case 222:
#line 750 "cfg-grammar.y"
{ 
		  configuration->time_sleep = yyvsp[-1].num; 
		  if (yyvsp[-1].num > 500) 
		    { 
		      msg_notice("The value specified for time_sleep is too large", evt_tag_int("time_sleep", yyvsp[-1].num), NULL);
		      configuration->time_sleep = 500;
		    }
		}
break;
case 223:
#line 758 "cfg-grammar.y"
{ configuration->log_fifo_size = yyvsp[-1].num; }
break;
case 224:
#line 759 "cfg-grammar.y"
{ configuration->log_iw_size = yyvsp[-1].num; }
break;
case 225:
#line 760 "cfg-grammar.y"
{ configuration->log_fetch_limit = yyvsp[-1].num; }
break;
case 226:
#line 761 "cfg-grammar.y"
{ configuration->log_msg_size = yyvsp[-1].num; }
break;
case 227:
#line 762 "cfg-grammar.y"
{ configuration->keep_timestamp = yyvsp[-1].num; }
break;
case 228:
#line 763 "cfg-grammar.y"
{ configuration->ts_format = cfg_ts_format_value(yyvsp[-1].cptr); free(yyvsp[-1].cptr); }
break;
case 229:
#line 764 "cfg-grammar.y"
{ configuration->frac_digits = yyvsp[-1].num; }
break;
case 230:
#line 765 "cfg-grammar.y"
{ /* ignored */; }
break;
case 231:
#line 766 "cfg-grammar.y"
{ /* ignored */; }
break;
case 232:
#line 767 "cfg-grammar.y"
{ configuration->create_dirs = yyvsp[-1].num; }
break;
case 233:
#line 768 "cfg-grammar.y"
{ cfg_file_owner_set(configuration, yyvsp[-1].cptr); free(yyvsp[-1].cptr); }
break;
case 234:
#line 769 "cfg-grammar.y"
{ cfg_file_group_set(configuration, yyvsp[-1].cptr); free(yyvsp[-1].cptr); }
break;
case 235:
#line 770 "cfg-grammar.y"
{ cfg_file_perm_set(configuration, yyvsp[-1].num); }
break;
case 236:
#line 771 "cfg-grammar.y"
{ cfg_dir_owner_set(configuration, yyvsp[-1].cptr); free(yyvsp[-1].cptr); }
break;
case 237:
#line 772 "cfg-grammar.y"
{ cfg_dir_group_set(configuration, yyvsp[-1].cptr); free(yyvsp[-1].cptr); }
break;
case 238:
#line 773 "cfg-grammar.y"
{ cfg_dir_perm_set(configuration, yyvsp[-1].num); }
break;
case 239:
#line 774 "cfg-grammar.y"
{ configuration->use_dns_cache = yyvsp[-1].num; }
break;
case 240:
#line 775 "cfg-grammar.y"
{ configuration->dns_cache_size = yyvsp[-1].num; }
break;
case 241:
#line 776 "cfg-grammar.y"
{ configuration->dns_cache_expire = yyvsp[-1].num; }
break;
case 242:
#line 778 "cfg-grammar.y"
{ configuration->dns_cache_expire_failed = yyvsp[-1].num; }
break;
case 243:
#line 779 "cfg-grammar.y"
{ configuration->dns_cache_hosts = yyvsp[-1].cptr; }
break;
case 244:
#line 780 "cfg-grammar.y"
{ configuration->file_template_name = yyvsp[-1].cptr; }
break;
case 245:
#line 781 "cfg-grammar.y"
{ configuration->proto_template_name = yyvsp[-1].cptr; }
break;
case 246:
#line 782 "cfg-grammar.y"
{ cfg_timezone_value(yyvsp[-1].cptr, &configuration->recv_zone_offset); free(yyvsp[-1].cptr); }
break;
case 247:
#line 783 "cfg-grammar.y"
{ cfg_timezone_value(yyvsp[-1].cptr, &configuration->send_zone_offset); free(yyvsp[-1].cptr); }
break;
case 248:
#line 787 "cfg-grammar.y"
{ yyval.ptr = log_filter_rule_new(yyvsp[-4].cptr, yyvsp[-2].node); free(yyvsp[-4].cptr); }
break;
case 249:
#line 791 "cfg-grammar.y"
{ yyval.node = yyvsp[0].node; if (!yyvsp[0].node) return 1; }
break;
case 250:
#line 792 "cfg-grammar.y"
{ yyvsp[0].node->comp = !(yyvsp[0].node->comp); yyval.node = yyvsp[0].node; }
break;
case 251:
#line 793 "cfg-grammar.y"
{ yyval.node = fop_or_new(yyvsp[-2].node, yyvsp[0].node); }
break;
case 252:
#line 794 "cfg-grammar.y"
{ yyval.node = fop_and_new(yyvsp[-2].node, yyvsp[0].node); }
break;
case 253:
#line 795 "cfg-grammar.y"
{ yyval.node = yyvsp[-1].node; }
break;
case 254:
#line 799 "cfg-grammar.y"
{ yyval.node = filter_facility_new(yyvsp[-1].num);  }
break;
case 255:
#line 800 "cfg-grammar.y"
{ yyval.node = filter_facility_new(0x80000000 | yyvsp[-1].num); }
break;
case 256:
#line 801 "cfg-grammar.y"
{ yyval.node = filter_level_new(yyvsp[-1].num); }
break;
case 257:
#line 802 "cfg-grammar.y"
{ yyval.node = filter_prog_new(yyvsp[-1].cptr); free(yyvsp[-1].cptr); }
break;
case 258:
#line 803 "cfg-grammar.y"
{ yyval.node = filter_host_new(yyvsp[-1].cptr); free(yyvsp[-1].cptr); }
break;
case 259:
#line 804 "cfg-grammar.y"
{ yyval.node = filter_match_new(yyvsp[-1].cptr); free(yyvsp[-1].cptr); }
break;
case 260:
#line 805 "cfg-grammar.y"
{ yyval.node = filter_call_new(yyvsp[-1].cptr, configuration); free(yyvsp[-1].cptr); }
break;
case 261:
#line 806 "cfg-grammar.y"
{ yyval.node = filter_netmask_new(yyvsp[-1].cptr); free(yyvsp[-1].cptr); }
break;
case 262:
#line 810 "cfg-grammar.y"
{ yyval.num = yyvsp[-1].num | yyvsp[0].num; }
break;
case 263:
#line 811 "cfg-grammar.y"
{ yyval.num = yyvsp[0].num; }
break;
case 264:
#line 816 "cfg-grammar.y"
{ 
	    int n = syslog_name_lookup_facility_by_name(yyvsp[0].cptr);
	    if (n == -1)
	      {
	        msg_error("Warning: Unknown facility", 
	                  evt_tag_str("facility", yyvsp[0].cptr),
	                  NULL);
	        yyval.num = 0;
	      }
	    else
	      yyval.num = (1 << n); 
	    free(yyvsp[0].cptr); 
	  }
break;
case 265:
#line 832 "cfg-grammar.y"
{ yyval.num = yyvsp[-1].num | yyvsp[0].num; }
break;
case 266:
#line 833 "cfg-grammar.y"
{ yyval.num = yyvsp[0].num; }
break;
case 267:
#line 838 "cfg-grammar.y"
{ 
	    int r1, r2;
	    r1 = syslog_name_lookup_level_by_name(yyvsp[-2].cptr);
	    if (r1 == -1)
	      msg_error("Warning: Unknown priority level",
                        evt_tag_str("priority", yyvsp[-2].cptr),
                        NULL);
	    r2 = syslog_name_lookup_level_by_name(yyvsp[0].cptr);
	    if (r2 == -1)
	      msg_error("Warning: Unknown priority level",
                        evt_tag_str("priority", yyvsp[-2].cptr),
                        NULL);
	    if (r1 != -1 && r2 != -1)
	      yyval.num = syslog_make_range(r1, r2); 
	    else
	      yyval.num = 0;
	    free(yyvsp[-2].cptr); 
	    free(yyvsp[0].cptr); 
	  }
break;
case 268:
#line 858 "cfg-grammar.y"
{ 
	    int n = syslog_name_lookup_level_by_name(yyvsp[0].cptr); 
	    if (n == -1)
	      {
	        msg_error("Warning: Unknown priority level",
                          evt_tag_str("priority", yyvsp[0].cptr),
                          NULL);
	        yyval.num = 0;
	      }
	    else
	      yyval.num = 1 << n;
	    free(yyvsp[0].cptr); 
	  }
break;
case 269:
#line 874 "cfg-grammar.y"
{ yyval.num = 1; }
break;
case 270:
#line 875 "cfg-grammar.y"
{ yyval.num = 0; }
break;
case 271:
#line 876 "cfg-grammar.y"
{ yyval.num = yyvsp[0].num; }
break;
case 272:
#line 880 "cfg-grammar.y"
{ yyval.num = yyvsp[0].num; }
break;
case 273:
#line 881 "cfg-grammar.y"
{ yyval.num = 2; }
break;
case 276:
#line 890 "cfg-grammar.y"
{ yyval.cptr = yyvsp[0].cptr; }
break;
case 277:
#line 891 "cfg-grammar.y"
{ char buf[16]; snprintf(buf, sizeof(buf), "%d", yyvsp[0].num); yyval.cptr = strdup(buf); }
break;
#line 2277 "cfg-grammar.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yysslim && yygrowstack())
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;

yyoverflow:
    yyerror("yacc stack overflow");

yyabort:
    return (1);

yyaccept:
    return (0);
}
